'----------------------------------------------------------------------------'
'                       SSD1331 display library                              '
'                          resolution 96x64                                  '
'                                                                            '
'                         BASCOM-AVR  2.0.7.8                                '
'                           Mrshilov 2016                                   '
'                            St-Peterburg                                    '
'                               RUSSIA                                       '
'                                                                            '
'----------------------------------------------------------------------------'
$regfile = "m644def.dat"
$crystal = 8000000
$hwstack = 64
$swstack = 64
$framesize = 64
Config Clockdiv = 1
Mcucr.7 = 1                                                 'Turn OFF JTAG
Mcucr.7 = 1

'------------------------------- Setup -----------------------------------------
$lib "glcd-SSD1331-SPI.lib"
Config Graphlcd = Color , Si = Portb.2 , Sclk = Portb.3 , A0 = Portc.0 , Cs1 = Portb.4 , Rst = Portc.1

'------------------- Variables & Constants -------------------------------------
Const Blue = &B00000011                                     ''predefined contants are making programming easier
Const Yellow = &B11111100
Const Red = &B11100000
Const Green = &B00011100
Const Black = &B00000000
Const White = &B11111111
Const Brightgreen = &B00111110
Const Darkgreen = &B00010100
Const Darkred = &B10100000
Const Darkblue = &B00000010
Const Brightblue = &B00011111
Const Orange = &B11111000
Const Violet = &B11100011

Dim I As Byte , N As Byte , M As Byte , P As Byte
'============================ Main prog ========================================
Initlcd
Cls

Do
   For I = 0 To 63 Step 5                                   'Dots
      For N = 0 To 95 Step 5
         Pset N , I , Red
      Next N
   Next I
   Wait 1


   Cls
   For I = 0 To 63 Step 4                                   'Lines
      Line(0 , I) -(95 , I) , Red
   Next I
   Wait 1
   For I = 0 To 95 Step 6
      Line(i , 0) -(i , 63) , Blue
   Next I
   Wait 1


   Cls
   Box(0 , 0) -(95 , 63) , Red                              'Empty Box
   Wait 1
   Box(5 , 5) -(90 , 58) , Blue
   Wait 1


   Boxfill(0 , 0) -(95 , 63) , Red : Wait 1                 'Clear LCD with Color
   Boxfill(0 , 0) -(95 , 63) , Green : Wait 1
   Boxfill(0 , 0) -(95 , 63) , Blue : Wait 1


   Boxfill(5 , 5) -(90 , 58) , Violet : Wait 1              'Filled Box
   Boxfill(10 , 10) -(85 , 53) , Yellow : Wait 1

   Cls
   For I = 2 To 31 Step 4                                   'Circles
      Circle(48 , 32) , I , Green
   Next I
   Wait 1


   Cls
   Setfont Color8x8
   For I = 0 To 56 Step 8
      Lcdat I , 3 , "LCD SSD1331" , Blue , Black            'Text
   Next I
   Wait 1

   Showpic 0 , 0 , Color
   Wait 1
   Showpic 0 , 0 , Flower
   Wait 1

   For I = 15 To 0 Step - 1                                 'Contrast
      Lcdcontrast I
      Waitms 250
   Next I
   Waitms 500
   For I = 1 To 15
      Lcdcontrast I
      Waitms 250
   Next I
   Cls
Loop

End

'-------------------------------------------------------------------------------
$include "color8x8.font"
Color:
$bgf "color.bgc"
Flower:
$bgf "flower.bgc"